from django.shortcuts import render_to_response
from django.http import HttpResponse, HttpResponseRedirect
from django.contrib import auth
from django.contrib.auth.decorators import login_required
from django.template import RequestContext

from project.main.models import CustomUser, Page


#--------------------------------------------------------------------------------------------------

def frontpage(request):
    from project.main.page import show

    """
    # generate random cumulative values
    from project.main.models import Measurement
    import random
    import datetime

    value = 1000
    timestamp = datetime.datetime(year = 2010, month = 1, day = 1, hour = 0, minute = 0)
    for i in range(0, 15000):
        m = Measurement()
        m.nad = 7315
        m.tag = "c7315.cumul_day"
        m.value = value
        m.timestamp = timestamp
        m.save()
        timestamp = timestamp + datetime.timedelta(seconds = 60)
        value += int(random.random() * 1000)
    """

    """
    # create default admin user
    from project.main.models import UserPermissions
    permissions = UserPermissions()
    permissions.set_admin_permissions()
    permissions.save()

    user = CustomUser()
    user.username = "admin"
    user.set_password("admin")
    user.active = True
    user.is_staff = True
    user.is_superuser = True
    user.permissions = permissions
    user.save()

    # create home page
    page = Page()
    page.name = "Home"
    page.data_folder = "./"
    page.author = user
    page.modified_by = user
    page.published = True
    page.public = True
    page.update_period_id = 1
    page.save()
    """

    return show(request, 1)

#--------------------------------------------------------------------------------------------------

def create_comm_request(request):

    class ControllerData:
        controller = None
        rw_access = False
        valid = False

    import project.settings
    import re
    from project.main.models import Plant, Controller

    args = []
    plant_id = 0
    checked_tags = []

    # internal tags are writtable by server admin only
    default_cdata = ControllerData()
    default_cdata.valid = True
    default_cdata.rw_access = request.user.is_authenticated() and request.user.permissions.is_server_admin
    nads = {0: default_cdata}

    # read params
    if request.method == "POST":
        for tag in request.POST.get("url").split("&"):
            try:
                key, value = tag.split("=")
            except:
                key = tag
                value = ""
            args.append({"key": key, "value": ""})
    else:
        for key in request.GET:
            value = request.GET.get(key)
            if key == "plant":
                plant_id = value
            else:
                args.append({"key": key, "value": value})

    # get plant
    try:
        plant = Plant.objects.get(plant=plant_id)
    except:
        plant = None

    for arg in args:
        key = arg["key"]
        value = arg["value"]

        try:
            nad = int(re.match("^c(\d+)\.", key).group(1))
        except:
            nad = 0

        if nads.has_key(nad):
            cdata = nads.get(nad)
        else:
            cdata = ControllerData()
            try:
                cdata.controller = Controller.objects.get(nad=nad, active=True)
                cdata.valid = True
                cdata.rw_access = cdata.controller.plant_id != 0  and cdata.controller.plant.user_has_rw_access(request.user)
            except:
                cdata.controller = None

            nads.update({nad: cdata})

        if cdata.valid:
            if value == "":
                checked_tags.append(key)
            elif cdata.rw_access:
                checked_tags.append("%s=%s" % (key, value))

    data = ""

    import socket
    query_string = "&".join(checked_tags)
    headers = [
        "CONTENT_LENGTH", "0",
        "QUERY_STRING", query_string,
        "REMOTE_ADDR", request.META.get("REMOTE_ADDR"),
        "REMOTE_PORT", request.META.get("SERVER_PORT"),
        "REQUEST_URI", request.path + "?" + request.META.get("QUERY_STRING"),
    ]

    headers = "\0".join(headers) + "\0"
    headers = "%d:%s," % (len(headers), headers)

    try:
        sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

        try:
            sock.connect((project.settings.SCGI_HOST, project.settings.SCGI_PORT))
            sock.send(headers)
            data = ""

            while True:
                rx = sock.recv(1024)
                if len(rx):
                    data += rx
                else:
                    break
            sock.close()
        except:
            pass
    except socket.error:
        pass

    if len(data):
        #reject HTTP header data if exists
        lines = data.split("\n")
        if len(lines) != 0 and lines[0].find("Status") == 0:
            lines = lines[3:]
            data = "\n".join(lines)

        return HttpResponse(data, mimetype="text/xml; charset=iso-8859-1")


    return HttpResponse("")

#--------------------------------------------------------------------------------------------------
