import settings


#--------------------------------------------------------------------------------------------------

def nad_str_to_nad(value):
    import re
    try:
        return int(re.match("^c(\d+)", value).group(1))
    except:
        return 0

#--------------------------------------------------------------------------------------------------

def localize_timestamp(tz, ts):
    import pytz, datetime
    now = datetime.datetime.utcnow()
    now = now.replace(tzinfo=pytz.utc)
    try:
        if tz:
            tz = pytz.timezone(tz)
            if tz:
                now = now.astimezone(tz)
                td = now.utcoffset()
                return ts + td
    except:
        pass
    return ts

#--------------------------------------------------------------------------------------------------

def get_controller_timezone(nad):

    import ConfigParser
    import re

    ini = ConfigParser.ConfigParser()
    res = "UTC"

    try:
        ini.readfp(open(settings.CYBRO_SCGI_SERVER_CONFIG))
    except:
        return res

    # loop through all plc nads
    for section in ini.sections():
        match = re.search(r'^c(\d+)$', section)
        if match and int(match.group(1)) == nad:
            try:
                res = ini.get(section, "Timezone")
            except:
                return res

    return res

#--------------------------------------------------------------------------------------------------

def str_to_float(s, default=0.0):
    try:
        return float(s.replace(",", "."))
    except:
        return default

#--------------------------------------------------------------------------------------------------

def str_to_int(s, default=0):
    try:
        return int(s)
    except:
        return default

#--------------------------------------------------------------------------------------------------